unit main;

interface

uses
   Forms, StdCtrls, dkCodecUtilsWin32;

type
  TForm1 = class(TForm)
    Label2: TLabel;
    MimeNameLabel: TLabel;
    AliasListBox: TListBox;
    AliasEdit: TEdit;
    AliasBtn: TButton;
    procedure SearchAlias(Sender: TObject);
    procedure AliasEditKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FCodec: TUnicodeCodec;
    procedure UpdateAliasList;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  Dialogs;

procedure TForm1.AliasEditKeyPress(Sender: TObject; var Key: Char);
begin
  if ord(key) = 13 then SearchAlias(Sender);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FCodec := TEncodingRepository.CreateCodecByAlias('US-ASCII');
  UpdateAliasList;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FCodec.Free;
end;

procedure TForm1.SearchAlias(Sender: TObject);
var
  NewCodec: TUnicodeCodec;
begin
  NewCodec := TEncodingRepository.CreateCodecByAlias(AliasEdit.Text);
  if Assigned(NewCodec) then begin
    FCodec.Free;
    FCodec := NewCodec;
    UpdateAliasList;
  end else
    ShowMessage('Alias not found.')
end;

procedure TForm1.UpdateAliasList;
var
  I: Integer;
begin
  MimeNameLabel.Caption:= FCodec.PreferredMIMEName;
  AliasListBox.Clear;
  for I := 0 to pred(FCodec.AliasCount) do
    AliasListBox.Items.Add(FCodec.Alias(I));
end;

end.
